function umaxQ=ESTIMATOR_PP(x0)
%INPUT x01: Conc biomasa;
%           deltat: lungime interval de evolutie
%OUTPUT: umin si umax din intervalul care asigura cresterea biomasei;
%                uoy- comanda care asigura un randament maxim pe intervalul de estimare

% Utilizeaza pt integrare XXEvalState care integreaza la randul lui cu
% XXBatchPBR ce foloseste un model cu 2 stari 
% (Conc biom, Specific Growth Rate)
% Principiu: Baleiaza valorile din vectorul Vector_q0 cu intensitati q0

Vector_u= 0.05:0.05:2.;
nv=length(Vector_u);

deltat=1.;%0.5;

Q=zeros(nv,1);

for j = 1:nv
  u0 = Vector_u(j);
  state=EstimateState(u0,x0,deltat); %state vector de stare de 5 componente 
  Q(j)=state(3)-x0(3);
  
end



% Find out j and umaxQ such that j is the bigest value for which Q(j)>=0
% and umaxQ=Vector_u(j)
j=1;
found=0;
while (j<=nv)&&(found==0)
    if(Q(j)<0)
        found=1;
    else 
         j=j+1;
    end
end
if (found==1)
    umaxQ=Vector_u(j-1);
else
    umaxQ=2.;
end


end

    


