% New article
% Evolutionary Algorithm EA1 for solving an Optimal Control Problem
%EA1 for PARK-RAMIREZ problem

alfa=0.2;
global Ncalls Ncalls_C;
%global u_vector;
global xmin xmax;
%global t_vector;
global X00;
global Nt;
%global ngene;
Nt=15;
t_fin=Nt;
%global command_index;
uRHC=zeros(1,Nt);
stare=zeros(Nt+1,5);
Ncalls_C=0;
X00=[0. 0. 1. 5. 1.];
k=0;
x0=X00;
stare(1,:)=x0;
xmin=0.;
xmax=2.0;



WithEstimator=1;





%***************************************************
%***************************************************
%         CLOSED-LOOP control structure
%***************************************************
%***************************************************
while k<=(t_fin-1) 
    
   
%  str=sprintf('#####                                                    k=%d',k);
%  disp(str);
 %k este capatul din stanga al orizontului de predictie
  %str=sprintf('#####  starea curenta=%7.3f',x0);disp(str);
  
 if (WithEstimator==1)
     umaxQ=ESTIMATOR_PP(x0); 
     %pause;
 % xm1, xM1 are the bounds of the first control value
     xm1=alfa*umaxQ;
     if (xm1<0.05)
         xm1=0.05;
     end
     xM1=umaxQ;
     if(xM1>xmax)
         xM1=xmax;
     end
     %disp([xm1 xM1]);
 else 
    xm1=xmin;
    xM1=xmax; 
    %disp([xm1 xM1]);
 end
 PredictedSeq=RHC_Predictor_EA(k,x0,xm1,xM1);
  Ncalls_C=Ncalls_C+Ncalls; 
 disp('************')
 %disp(PredictedSeq);
 %disp('length=');
 %disp(length(PredictedSeq));
 
[~, J]=eval_PR_step(PredictedSeq,x0);
str=sprintf('k=%2d  xm1=%4.2f   xM1=%4.2f J=%7.4f  Ncalls=%6d  Ncalls_C= %6d', ...
    k, xm1,xM1,J,Ncalls,Ncalls_C);
disp(str);
disp('****************************************')
%pause;

% TRIMITERE (sau SALVARE) COMANDA U(k)
 uk=PredictedSeq(1);
 uRHC(k+1)=uk;
%  str=sprintf('&&&  comanda trimisa la proces=%7.4f ',uk);
%  disp(str);
%disp('*********************************////////////');
  % CITIRE STARE CURENTA pt iteratia urmatoare
  % De fapt AICI SIMULEZ STAREA CURENTA
  xnext=RHC_RealProcessStep(uk,x0,k);
  x0=xnext;
  % x0 devine noua stare initiala
  %RPM = PM deci nu adaug nimic acum
  
  k=k+1;  %k pt iteratia urmatoare
  %memorare stare initiala pt pasul urmator
  stare(k+1,:)=x0;
  
end

% %Global simulation
% u_vector=[uRHC(1:Nt),uRHC(Nt)];
% t_vector=0:t_fin;
% figure(3)
% title('Optimal control - RHC-loop');
% stairs(t_vector,u_vector,'r');
% 
% command_index=1;
% %options = odeset('RelTol',1e-3,'MaxStep',1.5);
% [T,Y] = ode23('PRProd',t_vector,X00);
% J1=Y(end,1)*Y(end,5);disp(J1);
% 
% figure(4)
% plot(T,3*Y(:,1),'r',T,3*Y(:,2),'k',T,3*Y(:,3),'g',T,Y(:,4),'-.b',T,Y(:,5),'m');
% title('State evolution for the RHC-loop');
% legend('x1','x2','x3','x4','x5','Location','NorthWest');

[staref, JRHC]=Jfinal(uRHC);
disp(staref);
str=sprintf('&&&&    JRHC=%7.4f ',JRHC);
disp(str);




