load('WSPmod0.mat','UstarRHC','X15','JMAT','NcallsC'); 
Vector_u= 0.05:0.05:2.;
nv=length(Vector_u);
stare6=drawFinal6(UstarRHC);
%0.0324    0.0392    2.1878    0.8842    2.4485
disp(stare6);
Q=zeros(nv,1);
deltat=1.;
for j = 1:nv
  u0 = Vector_u(j);
  state=EstimateState(u0,stare6,deltat); %state vector de stare de 5 componente 
  Q(j)=state(3)-stare6(3);
  
end

plot([0.15,0.15],[-0.6,0.14],'--k',[0.75,0.75],[-0.6,0.],...
    '--k',Vector_u,0*Vector_u,'k',Vector_u,Q,'r',[0.15, 0.75],[-0.005,-0.005],'b');
title('Estimated state quality');
xlabel('Control output');
ylabel('x_{3}(u)-x_{30}');


