% Evolutionary Algorithm EA1 for solving an Optimal Control Problem
%EA1 for PARK-RAMIREZ problem

str=sprintf('EA1 for  PARK-RAMIREZ problem\nRunning of  EA_h15_A5.m');
disp(str);
% str=sprintf('Selectie cu Stochastic Universal Sampling');disp(str);
% str=sprintf('Utilizare Rank si Scalare Rank');disp(str);
% str=sprintf('Replacement: in ultimele lambda pozitii');disp(str);
% str=sprintf('             din cele N ale populatiei');disp(str);
% str=sprintf('Incrucisare: Intr-un singur punct');disp(str);
% str=sprintf('             -produce un singur urmas');disp(str);
% str=sprintf('Mutatie: gaussiana adaptiva');disp(str);

global t_vector;
global h Nt N s;
global pop;
global CHILD;
global ngene NGen;
global xmin xmax;
global fc fcCHILD;
global amic;
global u_vector;
global nr_fii;
global sigma msc mc;
global X00;
N=35;   % N=nr de cromozomi din populatie
nr_fii=30;
NGen=70;     % NGen=nr de generatii
fc=zeros(N,1);
fcCHILD=zeros(nr_fii,1);
xmax=2.;
xmin=0;
Nt=15;

t_vector=0:1:15; %are Nt+1 elemente
% stare=zeros(Nt+1,5);
% XFZ=zeros(1,5);
parinti=zeros(nr_fii,1);

s=1.8; %presiune de selectie
str=sprintf('#####  N=%d nr_fii=%d NGen=%d s=%g',N, nr_fii,NGen,s);
disp(str);
amic=0.85;

X00=[0. 0. 1. 5. 1.];
X0=X00;
%Xk este starea initiala pe orizontul de predictie [k,Nt]
%stare(1,:)=X0; %memorare stare initiala

R=N:-1:1; % Rangurile populatiei. Solutiile sunt ordonate;
          % miu=N
P=ScaleRank(R,N,s);%P contine rangurile scalate
lambda=nr_fii;
h=Nt;
ngene=h;
pop=zeros(N,ngene);
CHILD=zeros(nr_fii,ngene);
% Best control profile obtained with another metaheuristic
%u0=[0.0931 0.2995 0.2473 0.5186 0.4332 ...
%     0.9210 1.0229 1.4300 1.6566 1.8253 ...
%     0.2924 0.8604 0.8516 0.8595 1.2090];

%Generare populatie initiala
 for i=1:N  
    for j=1:ngene     
          pop(i,j)=random('unif',xmin,xmax);
    end;
%pop(i,:)=u0+random('Normal',0,0.1,1,ngene);
 end
 
%Evaluare initiala
for i=1:N
	[~,fc(i)]=eval_PR(pop(i,:));
end
[fc,IX]=sort(fc,1,'descend');
 pop=pop(IX,:);
sigma=0.4;
mc=0;
msc=0;
g=1;


%CICLU MARE de T ITERAII
%tttttttttttttttttttttttttttttttttttttttttttttttttttttt BEGIN
while(g<=NGen)         %&&(gasit==0)


% SELECTIE PARINTI
parinti=StUnSamp(P,N,lambda);%indicii parintilor
per=randperm(lambda);
parinti=parinti(per);%permutare aleatorie a indicilor

%INCRUCISARE - atentie aici se construiesc (apar) fii
for ii=1:lambda
      jj=1;%randi(lambda);
      crossover2(parinti(ii),jj,ii); %un singur copil
      %se incruciseaza pop(parinti(ii),:) cu alt cromozom din lista          
end
%------------------------------
 %MUTATIE (mutatieGaussRH contine si evaluarea)
 for iii=1:lambda
      [~,fcCHILD(iii)]=eval_PR(CHILD(iii,:));
      %Evalure inainte de mutatie pt toti fii
      %(valabila si daca nu voi face mutatie)
      
      daca_mut=randi(100);
      if(daca_mut<=90)      
        mutatieGauss5(iii); %Fac mutatie pe CHILD(iii)
      end
 end

 % Copiere fii pe ultimele lambda POZITII din cele N
 pop((N-lambda+1):N,:)=CHILD;
 fc((N-lambda+1):N)=fcCHILD;
 %------------------------------------
 % Reordonare pop dupa fc
 [fc,IX]=sort(fc,1,'descend');
 pop=pop(IX,:);   %reordoneaza
 if (mod(g,10)==0)
    str=sprintf('#####   nr. gen=%g sigma= %g Jmax=%g',g, sigma,fc(1));
    disp(str);
 end
 %------------------------------------
 
 g=g+1;

end     %while

%Alg A            END  
%****************************
%****************************
%****************************
u_vector=pop(1,:);

%simulare_cutrepte;
